# -*- coding=utf-8 -*-
from aptdaemon import client
from aptdaemon.errors import NotAuthorizedError, TransactionFailed
from gi.repository import GObject
import socket
import sys



if sys.argv[1] == 'install':
        installs = [sys.argv[2]]
        removes = []
elif sys.argv[1] == 'update':
        installs = [sys.argv[2]]
        removes = []
else:
        installs = []
        removes = [sys.argv[2]]


loop = GObject.MainLoop()
address = ('127.0.0.1', 8688)
s = socket.socket(socket.AF_INET, socket.SOCK_DGRAM)
isfinished=False

def sendMsg(o, msg):
        s.sendto(msg.encode(), address)
        
class Installer(GObject.GObject):
        __gsignals__ = {
                'sendMsg': (GObject.SIGNAL_RUN_FIRST, None,
                              (GObject.TYPE_STRING,))
                }
        def __init__(self):
                GObject.GObject.__init__(self)
                self.apt_client = client.AptClient()
                self.transaction = None
                self.connect('sendMsg', sendMsg)
                try:
                        self.transaction = self.apt_client.commit_packages(install = installs,remove=removes,
								reinstall=[], purge=removes, upgrade=[], downgrade=[])
                        self.transaction.set_allow_unauthenticated(allow_unauthenticated=2)
                        self.transaction.connect("progress-changed", self.change_progress)
                        self.transaction.connect("finished", self.finished)
                        self.transaction.connect("error", self.on_error)
                        self.transaction.run()
                except(NotAuthorizedError, TransactionFailed) as e:
                        print("Warning: install transaction not completed successfully: {}".format(e))
                
        def change_progress(self, tr, pr):
                msg = format(pr, '03d') + '执行中'
                print(msg)
                if not isfinished and pr != 100:
                        self.emit('sendMsg', msg)


        def finished(self, tr, exit_status):
                global s
                isfinished = True
                msg = '100完成'
                print(msg)
                self.emit('sendMsg', msg)
                loop.quit()

        def on_error(self, tr, error_code, error_details):
                if error_code == 'error-not-authorized':
                    msg = '-01' + '取消授权'
                else:
                    msg = '000' + '错误'
                print(msg)
                self.emit('sendMsg', msg)
                loop.quit()



print('loop.run()')
i = Installer()
loop.run()
print('over')

